/*******************************************************************

Copyright (c) 2004 Open Mobile Alliance, Ltd.  All Rights Reserved.

This software is made available under the usage and distribution terms 
covered by the Common Public License 1.0 and by using this software you
are bound by the terms and conditions of the same.

EXCEPT AS EXPRESSLY SET FORTH IN THE COMMON PUBLIC LICENSE,
THIS PROGRAM IS PROVIDED ON AN "AS IS" BASIS, 
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, 
ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, 
MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
   
Each recipient is solely responsible for determining the 
appropriateness of using and distributing this program and assumes 
all risks associated with its exercise of rights under the Common 
Public License, including but not limited to the risks and 
costs of program errors, compliance with applicable laws, 
damage to or loss of data, programs or equipment, and 
unavailability or interruption of operations.

********************************************************************/
// SCTS3DevMan.h : main header file for the SCTS3DEVMAN application
//

#if !defined(AFX_SCTS3DEVMAN_H__AC62F7C2_59F1_4404_9F70_AEC655804A8C__INCLUDED_)
#define AFX_SCTS3DEVMAN_H__AC62F7C2_59F1_4404_9F70_AEC655804A8C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include "SctsTransport.h"
#include "SCTS3DevManDlg.h"
#include "LoadError.h"
#include <atlbase.h>


/////////////////////////////////////////////////////////////////////////////
// CSCTS3DevManApp:
// See SCTS3DevMan.cpp for the implementation of this class
//
/* The mainPane */
extern CSCTS3DevManDlg *mainPane;
extern CTreeCtrl *navigator;

/* The transport servers */
extern SctsHttpTransportServer *httpServer;
extern SctsObexTCPTransportServer *obexTCPServer;
extern SctsObexIRTransportServer *obexIRServer;
extern SctsTransportServerState httpServerState;
extern SctsTransportServerState obexTCPServerState;
extern SctsTransportServerState obexIRServerState;
extern int httpServerPort;
extern int obexTCPServerPort;
extern char *obexIRServerService;

/* File paths */
extern CString appPath;
extern CString logPath;
extern time_t appTimeStamp;

/* Functions to start/stop the irmon service */
extern bool sctsRestartIrmon;
bool sctsStopIrmon();
bool sctsStartIrmon();

class CSCTS3DevManApp : public CWinApp
{
public:
	CSCTS3DevManApp();

	void ReadRegistry();
	void WriteRegistry();


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSCTS3DevManApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CSCTS3DevManApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SCTS3DEVMAN_H__AC62F7C2_59F1_4404_9F70_AEC655804A8C__INCLUDED_)
