/*******************************************************************

Copyright (c) 2004 Open Mobile Alliance, Ltd.  All Rights Reserved.

This software is made available under the usage and distribution terms 
covered by the Common Public License 1.0 and by using this software you
are bound by the terms and conditions of the same.

EXCEPT AS EXPRESSLY SET FORTH IN THE COMMON PUBLIC LICENSE,
THIS PROGRAM IS PROVIDED ON AN "AS IS" BASIS, 
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, 
EITHER EXPRESS OR IMPLIED INCLUDING, WITHOUT LIMITATION, 
ANY WARRANTIES OR CONDITIONS OF TITLE, NON-INFRINGEMENT, 
MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.
   
Each recipient is solely responsible for determining the 
appropriateness of using and distributing this program and assumes 
all risks associated with its exercise of rights under the Common 
Public License, including but not limited to the risks and 
costs of program errors, compliance with applicable laws, 
damage to or loss of data, programs or equipment, and 
unavailability or interruption of operations.

********************************************************************/
/*************************************************************************/
/* module:          SyncML Communication Protocol selection module       */
/* file:            src/xpt/win/xptitcp.h                                */
/* target system:   win                                                  */
/* target OS:       win                                                  */
/*************************************************************************/



/**
 * This module contains Windows specific definitions for the
 * TCP/IP protocol handler for SyncML
 * invokes the miscellaneous protocol drivers.
 *
 */

#ifndef XPTITCP_H
#define XPTITCP_H

#include <string.h>
#if __IBMC__||__IBMCPP__
#include <windows.h>
#else
#include <winsock.h>
#endif

// # of active sockets
static int _iNumSockets = 0;

/**************************************************************************/
/* The following macros check if the TCP/IP stack needs to be initialized */
/**************************************************************************/
#define TCPINIT(r) \
{ WSADATA wsadata; \
  if ((_iNumSockets++ == 0) && WSAStartup (0x0101, &wsadata)) (r)=(TcpRc_t)(WSAGetLastError()-WSABASEERR); }
#define TCPTERM() if (--iNumSockets == 0) WSACleanup ()


/********************************************************/
/* The following macro checks if the socket is in error */
/********************************************************/
#define CHKERROR(r) \
   (TcpRc_t)(((r)==SOCKET_ERROR||(r)==INVALID_SOCKET)?(WSAGetLastError()-WSABASEERR):TCP_RC_OK)



#endif

/* eof */
